package com.sv.service.oms;
import com.github.pagehelper.PageHelper;
import com.ydd.framework.core.common.Pagination;
import com.ydd.framework.core.entity.enums.StatusEnum;
import com.ydd.framework.core.service.impl.BaseServiceImpl;

import com.sv.entity.VenueLessonTicket;
import com.sv.mapper.VenueLessonTicketMapper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;

/**
 * Service - 课程票据
 *
 * @author zhaoziyu
 * @since 2018-08-06
 */
@Service("VenueLessonTicketServiceOms")
@Transactional(readOnly = true)
public class VenueLessonTicketService extends BaseServiceImpl{

	private final Logger logger = LoggerFactory.getLogger(VenueLessonTicketService.class);

	@Resource
	private VenueLessonTicketMapper venueLessonTicketMapper;

	/**
	 * 创建课程票据
	 *
	 * @param venueLessonTicket 课程票据
	 */
	
	@Transactional
    public void save(VenueLessonTicket venueLessonTicket) {
		if (venueLessonTicket.getId() != null && venueLessonTicket.getId() > 0) {
			// 更新
			venueLessonTicketMapper.update(venueLessonTicket);
		} else {
			// 新建
			venueLessonTicketMapper.insert(venueLessonTicket);
		}
	}

	/**
	 * 更新课程票据
 	 *
	 * @param venueLessonTicket 课程票据
	 */
	
	@Transactional
    public void update(VenueLessonTicket venueLessonTicket) {
		venueLessonTicketMapper.update(venueLessonTicket);
	}

	/**
	 * 删除课程票据
	 *
	 * @param id 编号
   	 * @return 删除数量
	 */
	
	@Transactional
    public Integer delete(Integer id) {
		if (id == null || id <= 0) {
			return 0;
		}
		return venueLessonTicketMapper.delete(id);
	}

	/**
	 * 删除课程票据
	 *
	 * @param ids 编号数组
	 * @return 删除数量
	 */
	
	@Transactional
    public Integer deleteByIds(Integer[] ids) {
		if (ids == null || ids.length == 0) {
			return 0;
		}
		return venueLessonTicketMapper.deleteByIds(ids);
	}

	/**
	 * 查询课程票据
	 *
	 * @param id 编号
	 * @return 课程票据
	 */
	public VenueLessonTicket findById(Integer id) {
		return venueLessonTicketMapper.findById(id);
	}

	/**
	 * 查询课程票据
	 *
	 * @param pagination 分页信息
	 * @return 分页结果
	 */
	
	public Pagination findPage(Pagination pagination) {
		PageHelper.startPage(pagination.getPage(), pagination.getPageSize());
		PageHelper.orderBy("id desc");
		pagination.setQueryResult(venueLessonTicketMapper.findAll());
		return pagination;
	}

	/**
	 * 更新状态
	 *
	 * @param ids 编号
	 * @param status 状态
	 * @return 更新数量
	 */
	
	@Transactional
	public Integer updateStatus(Integer[] ids, Byte status) {
		if (ids == null) {
			return 0;
		}
		if (status == null) {
			status = StatusEnum.DISABLE.value;
		}

		return venueLessonTicketMapper.updateStatus(ids, status);
	}

}

